// common/http.interceptor.js
import url from "./url.js"
import md5Libs from "../uview-ui/libs/function/md5.js"
// console.log(url);
// 这里的Vue为Vue对象(非创建出来的实例)，vm为main.js中“Vue.use(httpInterceptor, app)”这一句的第二个参数，
// 为一个Vue的实例，也即每个页面的"this"
// 如果需要了解这个install方法是什么，请移步：https://uviewui.com/components/vueUse.html
const install = (Vue, vm) => {
	// 此为自定义配置参数，具体参数见上方说明
	Vue.prototype.$u.http.setConfig({
		baseUrl: url,
		loadingText: '努力加载中~',
		loadingTime: 800,
		// 设置自定义头部content-type
		// header: {
		// 	'content-type': 'application/x-www-form-urlencoded'
		// }
		// ......
	});
	// 请求拦截部分，如配置，每次请求前都会执行
	Vue.prototype.$u.http.interceptor.request = (config) => {
		// 引用token
		// 方式一，存放在vuex的token，假设使用了uView封装的vuex方式
		// 见：https://uviewui.com/components/globalVariable.html
		// config.header.token = vm.token;

		// 方式二，如果没有使用uView封装的vuex方法，那么需要使用$store.state获取
		// config.header.token = vm.$store.state.token;

		// 方式三，如果token放在了globalData，通过getApp().globalData获取
		// config.header.token = getApp().globalData.username;

		// 方式四，如果token放在了Storage本地存储中，拦截是每次请求都执行的
		// 所以哪怕您重新登录修改了Storage，下一次的请求将会是最新值
		
		const token = uni.getStorageSync('token');
		if (config.method == "POST") {
			var timestamp = parseInt(new Date().getTime() / 1000)
			var secret_key = 'cXab5HR4pfBjdDryr2JjwbreieKVjA'
			var params = config.data.content
			var str = '';
			for (var Key in params) {
				str += Key + '=' + params[Key] + '&';
			}
			var sign = md5Libs.md5(`${str}timestamp=${timestamp}&secret_key=${secret_key}`)
			// console.log(`${str}timestamp=${timestamp}&secret_key=${secret_key}`);
			var phonetype = uni.getSystemInfoSync().model
			config.data.header = config.data.header || {}
			config.data.header.sign = sign
			config.data.header.timestamp = timestamp
			config.data.header.phonetype = phonetype
			config.data.header.category = 3
			config.data.header.secret_key = secret_key
			// config.data.header.debug = "5CDAC27A0F89C916553DE870F3C55181"//默认登录
			config.data.header.version_name = ""//默认数据beta2
			config.data.header.token = token;
			config.data = {
				request: JSON.stringify(config.data) //config.data
			}
		}
		// console.log(config.data);
		config.header.token = token;
		// 可以对某个url进行特别处理，此url参数为this.$u.get(url)中的url值
		// if (config.url == '/user/login') config.header.noToken = true;
		// 最后需要将config进行return
		return config;
		// 如果return一个false值，则会取消本次请求
		// if(config.url == '/user/rest') return false; // 取消某次请求
	}
}

export default {
	install
}
