import md5Libs from "../uview-ui/libs/function/md5.js";

function connectSocket() {
	var token = uni.getStorageSync("token")
	var timestamp = (new Date().getTime() / 1000).toFixed(0)
	var newtoken = md5Libs.md5('hRoalKzcVQrX7sq9o4LPnUxUcvYYyj69' + timestamp).toUpperCase()
	uni.connectSocket({
		url: `wss://wss.dd.ponyinfo.net/xiaoma/message/${newtoken}/${timestamp}`,
		success: (res) => {
			console.log(res);
		}
	})
}
function closeSocket(){
	uni.closeSocket({
		success:(res) => {
			console.log("socket链接关闭");
		}
	})
}
// 接受到消息并抛出
function getMessage(callback = function() {}) {
	// 接受消息
	uni.onSocketMessage((res) => {
		callback(res)
	})
}
// 接受消息
uni.onSocketMessage((res) => {
	// console.log("-------这里-------");
	// console.log(res);
	// console.log("------------------");
	if (JSON.parse(res.data).code == '0000') {
		uni.$u.post('/User/setWebsocketId', {
			content: {
				websocket_id: JSON.parse(res.data).message
			}
		}).then(res => {
			console.log("设置websocket_id成功");
		})
	}
})
// 监听链接成功
uni.onSocketOpen((res) => {
	console.log(res);
	console.log('WebSocket连接已打开！');
	if(time){
		// 防止重连触发多次，清除上次定时
		clearTimeout(time)
	}
	sendMsg()
});
// 监听链接失败
uni.onSocketError((res) => {
	console.log(res);
	console.log('WebSocket连接打开失败，3秒后重连！');
	setTimeout(() => {
		connectSocket()
	}, 3000)
});
// 监听链接关闭
uni.onSocketClose((res) => {
	if(time){
		// 防止重连触发多次，清除上次定时
		clearTimeout(time)
	}
})
var time = ''
// 3分钟发送一次服务器消息
function sendMsg(){
	uni.sendSocketMessage({
		data:{
			text:123
		},
		success: () => {
			time = setTimeout(() => {
				sendMsg()
			},180000)
		}
	})
}
export default {
	connectSocket,
	getMessage,
	closeSocket
}
